## snort 3.10.0.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5)
project (snort CXX C)

set (VERSION_MAJOR 3)
set (VERSION_MINOR 10)
set (VERSION_PATCH 0)
set (VERSION_SUBLEVEL 0)
set (VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_SUBLEVEL}")

if (DEFINED VERSION_BUILD)
    set (BUILD "${VERSION_BUILD}")
endif ()

set (CMAKE_CXX_STANDARD 17)
set (CMAKE_CXX_STANDARD_REQUIRED ON)
set (CMAKE_CXX_EXTENSIONS OFF)

set (CMAKE_C_STANDARD 99)
set (CMAKE_C_STANDARD_REQUIRED ON)
set (CMAKE_C_EXTENSIONS ON)

# dump compile_commands.json to make it easier to use clangd with IDEs
set (CMAKE_EXPORT_COMPILE_COMMANDS ON)

set (CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
# Pull in definitions of various install directories
include (GNUInstallDirs)
include (${CMAKE_MODULE_PATH}/macros.cmake)
include (${CMAKE_MODULE_PATH}/create_options.cmake)
include (${CMAKE_MODULE_PATH}/include_libraries.cmake)
include (${CMAKE_MODULE_PATH}/platforms.cmake)
include (${CMAKE_MODULE_PATH}/configure_options.cmake)
#include (${CMAKE_MODULE_PATH}/compiler_features.cmake)
include (${CMAKE_MODULE_PATH}/sanity_checks.cmake)

set (INSTALL_SUFFIX "${CMAKE_PROJECT_NAME}")
set (INCLUDE_INSTALL_PATH "${CMAKE_INSTALL_INCLUDEDIR}/${INSTALL_SUFFIX}")
set (LIB_INSTALL_PATH "${CMAKE_INSTALL_LIBDIR}/${INSTALL_SUFFIX}")
set (PLUGIN_INSTALL_PATH "${LIB_INSTALL_PATH}/plugins")

configure_file (
    "${PROJECT_SOURCE_DIR}/config.cmake.h.in"
    "${PROJECT_BINARY_DIR}/config.h"
)

add_definitions( -DHAVE_CONFIG_H )

# Set these after all tests are done but *before* any subdirectories are included
#  or other targets declared.
string(APPEND CMAKE_C_FLAGS " ${EXTRA_C_FLAGS}")
string(APPEND CMAKE_CXX_FLAGS " ${EXTRA_CXX_FLAGS}")
string(APPEND CMAKE_EXE_LINKER_FLAGS " ${EXTRA_LINKER_FLAGS}")
string(APPEND CMAKE_MODULE_LINKER_FLAGS " ${EXTRA_LINKER_FLAGS}")

include_directories (${PROJECT_BINARY_DIR})
include_directories (${PROJECT_SOURCE_DIR})

if (ENABLE_UNIT_TESTS)
    include(CTest)
endif (ENABLE_UNIT_TESTS)

if (ENABLE_UNIT_TESTS OR ENABLE_BENCHMARK_TESTS)
    add_custom_target (check COMMAND ${CMAKE_CTEST_COMMAND})
endif (ENABLE_UNIT_TESTS OR ENABLE_BENCHMARK_TESTS)

add_subdirectory (src)
add_subdirectory (tools)
add_subdirectory (lua)
add_subdirectory (daqs)

if ( MAKE_DOC )
    add_subdirectory (doc)
endif ( MAKE_DOC )

# Miscellaneous stuff.  Does NOT directly affect Snort's build environment.
include (${CMAKE_MODULE_PATH}/packaging_data.cmake)
include (${CMAKE_MODULE_PATH}/create_pkg_config.cmake)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

string(TOUPPER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_UPPER)

message("
-------------------------------------------------------")
if (DEFINED BUILD)
    message("${CMAKE_PROJECT_NAME} version ${VERSION} build ${BUILD}")
else()
    message("${CMAKE_PROJECT_NAME} version ${VERSION}")
endif()
message("
Install options:
    prefix:     ${CMAKE_INSTALL_PREFIX}
    includes:   ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${INSTALL_SUFFIX}
    plugins:    ${CMAKE_INSTALL_FULL_LIBDIR}/${INSTALL_SUFFIX}

Compiler options:
    CC:             ${CMAKE_C_COMPILER}
    CXX:            ${CMAKE_CXX_COMPILER}
    CFLAGS:         ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE_UPPER}}
    CXXFLAGS:       ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE_UPPER}}
    EXE_LDFLAGS:    ${CMAKE_EXE_LINKER_FLAGS}
    MODULE_LDFLAGS: ${CMAKE_MODULE_LINKER_FLAGS}

Feature options:\
")

if (ENABLE_STATIC_DAQ)
    message("\
    DAQ Modules:    Static (${DAQ_STATIC_MODULES})")
else ()
    message("\
    DAQ Modules:    Dynamic")
endif ()

if (HAVE_ATOMIC)
    message("\
    libatomic:      User-specified")
else ()
    message("\
    libatomic:      System-provided")
endif ()

if (HAVE_HYPERSCAN)
    message("\
    Hyperscan:      ON")
else ()
    message("\
    Hyperscan:      OFF")
endif ()

if (HAVE_ICONV)
    message("\
    ICONV:          ON")
else ()
    message("\
    ICONV:          OFF")
endif ()

if (HAVE_LIBUNWIND)
    message("\
    Libunwind:      ON")
else ()
    message("\
    Libunwind:      OFF")
endif ()

if (HAVE_LZMA)
    message("\
    LZMA:           ON")
else ()
    message("\
    LZMA:           OFF")
endif ()

if (USE_TIRPC)
    message("\
    RPC DB:         TIRPC")
else ()
    message("\
    RPC DB:         Built-in")
endif ()

if (HAVE_SAFEC)
    message("\
    SafeC:          ON")
else ()
    message("\
    SafeC:          OFF")
endif ()

if (HAVE_TCMALLOC)
    message("\
    TCMalloc:       ON")
else ()
    message("\
    TCMalloc:       OFF")
endif ()

if (HAVE_JEMALLOC)
    message("\
    JEMalloc:       ON")
else ()
    message("\
    JEMalloc:       OFF")
endif ()

if (HAVE_UUID)
    message("\
    UUID:           ON")
else ()
    message("\
    UUID:           OFF")
endif ()

if (HAVE_NUMA)
    message("\
    NUMA:           ON")
else ()
    message("\
    NUMA:           OFF")
endif ()

if (HAVE_LIBML)
    message("\
    LibML:          ON")
else ()
    message("\
    LibML:          OFF")
endif ()

message("-------------------------------------------------------\n")

=== src/CMakeLists.txt ===

# keeping track of external libraries seperately for use in pkg-config.
set(EXTERNAL_LIBRARIES
    ${DAQ_LIBRARIES}
    ${DNET_LIBRARIES}
    ${CLANG_CXX_LIBRARY}
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT} # GCC says we must link to the threads library
    ${HWLOC_LIBRARIES}
    ${LUAJIT_LIBRARIES}
    ${OPENSSL_CRYPTO_LIBRARY}
    ${PCAP_LIBRARIES}
    ${PCRE2_LIBRARIES}
    ${ZLIB_LIBRARIES}
)

set(EXTERNAL_INCLUDES
    ${DAQ_INCLUDE_DIR}
    ${DNET_INCLUDE_DIR}
    ${FLEX_INCLUDES}
    ${HWLOC_INCLUDE_DIRS}
    ${OPENSSL_INCLUDE_DIR}
    ${PCAP_INCLUDE_DIR}
    ${PCRE2_INCLUDE_DIR}
    ${ZLIB_INCLUDE_DIRS}
)

if ( ENABLE_STATIC_DAQ )
    LIST(APPEND EXTERNAL_LIBRARIES ${DAQ_STATIC_MODULE_LIBS})
endif ()

if ( HAVE_ATOMIC )
    LIST(APPEND EXTERNAL_LIBRARIES ${ATOMIC_LIBRARIES})
endif()

if ( HAVE_HYPERSCAN )
    LIST(APPEND EXTERNAL_LIBRARIES ${HS_LIBRARIES})
    LIST(APPEND EXTERNAL_INCLUDES ${HS_INCLUDE_DIRS})
endif ()

if ( HAVE_ICONV )
    LIST(APPEND EXTERNAL_LIBRARIES ${ICONV_LIBRARY})
    LIST(APPEND EXTERNAL_INCLUDES ${ICONV_INCLUDE_DIR})
endif ()

if ( HAVE_LIBUNWIND )
    LIST(APPEND EXTERNAL_LIBRARIES ${LIBUNWIND_LIBRARIES})
    LIST(APPEND EXTERNAL_INCLUDES ${LIBUNWIND_INCLUDE_DIRS})
endif ()

if ( HAVE_LZMA )
    LIST(APPEND EXTERNAL_LIBRARIES ${LIBLZMA_LIBRARIES})
endif()

if ( HAVE_NUMA )
    LIST(APPEND EXTERNAL_INCLUDES ${NUMA_INCLUDE_DIRS})
    LIST(APPEND EXTERNAL_LIBRARIES ${NUMA_LIBRARIES})
endif()

if ( HAVE_SAFEC )
    LIST(APPEND EXTERNAL_LIBRARIES ${SAFEC_LIBRARIES})
    LIST(APPEND EXTERNAL_INCLUDES ${SAFEC_INCLUDE_DIR})
endif ()

if ( HAVE_UUID )
    LIST(APPEND EXTERNAL_LIBRARIES ${UUID_LIBRARY})
    LIST(APPEND EXTERNAL_INCLUDES ${UUID_INCLUDE_DIR})
endif ()

if ( USE_TIRPC )
    LIST(APPEND EXTERNAL_LIBRARIES ${TIRPC_LIBRARIES})
    LIST(APPEND EXTERNAL_INCLUDES ${TIRPC_INCLUDE_DIRS})
endif ()

if ( HAVE_LIBML )
    LIST(APPEND EXTERNAL_LIBRARIES ${ML_LIBRARIES})
    LIST(APPEND EXTERNAL_INCLUDES ${ML_INCLUDE_DIRS})
endif ()

include_directories(BEFORE ${LUAJIT_INCLUDE_DIR})
include_directories(AFTER ${EXTERNAL_INCLUDES})

# prepending all of these to ensure they are included before External Libs
include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
include_directories(BEFORE network_inspectors)

if ( ENABLE_UNIT_TESTS )
    enable_testing()
endif ( ENABLE_UNIT_TESTS )

if ( ENABLE_UNIT_TESTS OR ENABLE_BENCHMARK_TESTS )
    set( UNIT_TESTS_LIBRARIES $<TARGET_OBJECTS:catch_tests>)
    add_subdirectory(catch)
endif ( ENABLE_UNIT_TESTS OR ENABLE_BENCHMARK_TESTS )

add_subdirectory(actions)
add_subdirectory(codecs)
add_subdirectory(control)
add_subdirectory(detection)
add_subdirectory(dump_config)
add_subdirectory(events)
add_subdirectory(file_api)
add_subdirectory(filters)
add_subdirectory(flow)
add_subdirectory(framework)
add_subdirectory(hash)
add_subdirectory(js_norm)
add_subdirectory(latency)
add_subdirectory(log)
add_subdirectory(main)
add_subdirectory(managers)
add_subdirectory(memory)
add_subdirectory(mime)
add_subdirectory(packet_io)
add_subdirectory(parser)
add_subdirectory(payload_injector)
add_subdirectory(ports)
add_subdirectory(protocols)
add_subdirectory(sfip)
add_subdirectory(sfrt)
add_subdirectory(service_inspectors)
add_subdirectory(stream)
add_subdirectory(target_based)
add_subdirectory(host_tracker)
add_subdirectory(pub_sub)
add_subdirectory(time)
add_subdirectory(profiler)
add_subdirectory(trace)
add_subdirectory(utils)
add_subdirectory(helpers)
add_subdirectory(lua)
add_subdirectory(decompress)
add_subdirectory(ips_options)
add_subdirectory(loggers)
add_subdirectory(network_inspectors)
add_subdirectory(policy_selectors)
add_subdirectory(search_engines)
add_subdirectory(side_channel)
add_subdirectory(connectors)
add_subdirectory(mp_transport)


# FIXIT-L Delegate building out the target objects list to subdirectories

#  The main Snort executable
add_executable( snort
    main.h
    main.cc
    $<TARGET_OBJECTS:codecs>
    $<TARGET_OBJECTS:connectors>
    $<TARGET_OBJECTS:control>
    $<TARGET_OBJECTS:decompress>
    $<TARGET_OBJECTS:detection>
    $<TARGET_OBJECTS:dump_config>
    $<TARGET_OBJECTS:events>
    $<TARGET_OBJECTS:file_api>
    $<TARGET_OBJECTS:file_connector>
    $<TARGET_OBJECTS:filter>
    $<TARGET_OBJECTS:flow>
    $<TARGET_OBJECTS:framework>
    $<TARGET_OBJECTS:hash>
    $<TARGET_OBJECTS:helpers>
    $<TARGET_OBJECTS:host_tracker>
    $<TARGET_OBJECTS:ips_actions>
    $<TARGET_OBJECTS:ips_options>
    $<TARGET_OBJECTS:js_norm>
    $<TARGET_OBJECTS:latency>
    $<TARGET_OBJECTS:log>
    $<TARGET_OBJECTS:loggers>
    $<TARGET_OBJECTS:lua>
    $<TARGET_OBJECTS:main>
    $<TARGET_OBJECTS:managers>
    $<TARGET_OBJECTS:memory>
    $<TARGET_OBJECTS:mime>
    $<TARGET_OBJECTS:network_inspectors>
    $<TARGET_OBJECTS:policy_selectors>
    $<TARGET_OBJECTS:packet_io>
    $<TARGET_OBJECTS:parser>
    $<TARGET_OBJECTS:payload_injector>
    $<TARGET_OBJECTS:ports>
    $<TARGET_OBJECTS:profiler>
    $<TARGET_OBJECTS:protocols>
    $<TARGET_OBJECTS:pub_sub>
    $<TARGET_OBJECTS:search_engines>
    $<TARGET_OBJECTS:service_inspectors>
    $<TARGET_OBJECTS:sfip>
    $<TARGET_OBJECTS:sfrt>
    $<TARGET_OBJECTS:side_channel>
    $<TARGET_OBJECTS:std_connector>
    $<TARGET_OBJECTS:stream>
    $<TARGET_OBJECTS:stream_base>
    $<TARGET_OBJECTS:stream_ip>
    $<TARGET_OBJECTS:stream_icmp>
    $<TARGET_OBJECTS:stream_tcp>
    $<TARGET_OBJECTS:stream_udp>
    $<TARGET_OBJECTS:stream_user>
    $<TARGET_OBJECTS:stream_file>
    $<TARGET_OBJECTS:stream_paf>
    $<TARGET_OBJECTS:target_based>
    $<TARGET_OBJECTS:tcp_connector>
    $<TARGET_OBJECTS:unixdomain_connector>
    $<TARGET_OBJECTS:mp_unix_transport>
    $<TARGET_OBJECTS:time>
    $<TARGET_OBJECTS:trace>
    $<TARGET_OBJECTS:mp_transports>
    $<TARGET_OBJECTS:utils>
    ${STATIC_CODEC_PLUGINS}
    ${STATIC_NETWORK_INSPECTOR_PLUGINS}
    ${STATIC_SERVICE_INSPECTOR_PLUGINS}
    ${STATIC_POLICY_SELECTOR_PLUGINS}
    ${UNIT_TESTS_LIBRARIES}
)

#[[
message("
    STATIC_CODEC_PLUGINS = ${STATIC_CODEC_PLUGINS}
    STATIC_NETWORK_INSPECTOR_PLUGINS = ${STATIC_NETWORK_INSPECTOR_PLUGINS}
    STATIC_SERVICE_INSPECTOR_PLUGINS = ${STATIC_SERVICE_INSPECTOR_PLUGINS}
")
]]

target_link_libraries( snort
    ${EXTERNAL_LIBRARIES}
    ${EXTRA_LIBRARIES}
)

# Solaris requires libnsl and libsocket for various network-related library functions
if ( CMAKE_SYSTEM_NAME STREQUAL SunOS )
    target_link_libraries(snort nsl socket)
endif ()

#  setting export properties
set_property(TARGET snort APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES
    ${LUAJIT_INCLUDE_DIR}
    ${EXTERNAL_INCLUDES}
    # The installed path '${INCLUDE_INSTALL_PATH}'' is added below with 'install (... snort ...)'
)

set_property(TARGET snort APPEND PROPERTY INTERFACE_COMPILE_OPTIONS "${CMAKE_CXX_FLAGS}")

set_property(TARGET snort PROPERTY ENABLE_EXPORTS 1)

install (TARGETS snort
    # EXPORT snortexe
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

# FIXIT-L Restore CMake export information
#install (EXPORT snortexe
#    DESTINATION ${CMAKE_INSTALL_LIBDIR}/snort
#    FILE snort.cmake
#)

=== src/connectors/CMakeLists.txt ===
add_subdirectory(file_connector)
add_subdirectory(tcp_connector)
add_subdirectory(std_connector)
add_subdirectory(unixdomain_connector)

add_library( connectors OBJECT
    connectors.cc
    connectors.h
)

=== src/detection/CMakeLists.txt ===

set (DETECTION_INCLUDES
    detection_buf.h
    detection_engine.h
    extract.h
    ips_context.h
    ips_context_chain.h
    ips_context_data.h
    pattern_match_data.h
    rule_option_types.h
)

add_library (detection OBJECT
    ${DETECTION_INCLUDES}
    context_switcher.cc
    context_switcher.h
    detect.cc
    detect.h
    detection_continuation.h
    detection_engine.cc
    detection_module.cc
    detection_module.h
    detection_options.cc
    detection_options.h
    detect_trace.cc
    detect_trace.h
    event_trace.cc
    event_trace.h
    extract.cc
    fp_config.cc
    fp_config.h
    fp_create.cc
    fp_create.h
    fp_detect.cc
    fp_detect.h
    fp_utils.cc
    fp_utils.h
    ips_context.cc
    ips_context_chain.cc
    ips_context_data.cc
    pcrm.cc
    pcrm.h
    regex_offload.cc
    regex_offload.h
    rtn_checks.cc
    rtn_checks.h
    rules.cc
    rules.h
    service_map.cc
    service_map.h
    sfrim.cc
    sfrim.h
    signature.cc
    signature.h
    treenodes.cc
    treenodes.h
    tag.cc
    tag.h
)

install(FILES ${DETECTION_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/detection"
)

=== src/main/CMakeLists.txt ===

set (INCLUDES
    analyzer_command.h
    policy.h
    reload_tracker.h
    reload_tuner.h
    snort_config.h
    snort_types.h
    thread.h
    thread_config.h
    snort.h
)

set (LOCAL_INCLUDES
    ${CMAKE_CURRENT_BINARY_DIR}/lua_bootstrap.h
    ${CMAKE_CURRENT_BINARY_DIR}/lua_finalize.h
)

if ( ENABLE_SHELL )
    set ( SHELL_SOURCES ac_shell_cmd.h ac_shell_cmd.cc)
endif ( ENABLE_SHELL )

add_subdirectory(test)

if ( HAVE_NUMA )
    set ( NUMA_SOURCES numa.h numa.cc)
endif( HAVE_NUMA )

add_library (main OBJECT
    analyzer.cc
    analyzer.h
    analyzer_command.cc
    help.cc
    help.h
    modules.cc
    modules.h
    network_module.cc
    network_module.h
    oops_handler.cc
    oops_handler.h
    policy.cc
    process.cc
    process.h
    reload_tracker.cc
    shell.h
    shell.cc
    snort.cc
    snort.h
    snort_config.cc
    snort_module.h
    snort_module.cc
    swapper.cc
    swapper.h
    thread.cc
    thread_config.h
    thread_config.cc
    ${INCLUDES}
    ${LOCAL_INCLUDES}
    ${SHELL_SOURCES}
    ${NUMA_SOURCES}
)

add_custom_command (
    OUTPUT lua_bootstrap.h
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../lua_wrap.sh ${CMAKE_CURRENT_SOURCE_DIR} bootstrap > lua_bootstrap.h
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/bootstrap.lua
)

add_custom_command (
    OUTPUT lua_finalize.h
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/../lua_wrap.sh ${CMAKE_CURRENT_SOURCE_DIR} finalize > lua_finalize.h
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/finalize.lua
)

include_directories (${CMAKE_CURRENT_BINARY_DIR})

install (FILES ${INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/main"
)

=== src/mime/CMakeLists.txt ===

set( MIME_INCLUDES
    decode_b64.h
    decode_base.h
    file_mime_config.h
    file_mime_decode.h
    file_mime_log.h
    file_mime_paf.h
    file_mime_process.h
)

add_library ( mime OBJECT
    ${MIME_INCLUDES}
    decode_b64.cc
    decode_base.cc
    decode_bit.cc
    decode_bit.h
    decode_buffer.cc
    decode_buffer.h
    decode_qp.cc
    decode_qp.h
    decode_uu.cc
    decode_uu.h
    file_mime_config.cc
    file_mime_context_data.cc
    file_mime_context_data.h
    file_mime_decode.cc
    file_mime_log.cc
    file_mime_paf.cc
    file_mime_process.cc
)

install (FILES ${MIME_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/mime"
)

=== src/protocols/CMakeLists.txt ===

set (PROTOCOL_HEADERS
    arp.h
    bpdu.h
    cdp.h
    cisco_meta_data.h
    eapol.h
    eth.h
    icmp4.h
    icmp6.h
    ip.h
    ipv4.h
    ipv4_options.h
    ipv6.h
    geneve.h
    gre.h
    layer.h
    linux_sll.h
    mpls.h
    packet.h
    packet_manager.h
    protocol_ids.h
    ssl.h
    tcp.h
    tcp_options.h
    teredo.h
    token_ring.h
    udp.h
    wlan.h
    vlan.h
)

add_library (protocols OBJECT
    ${PROTOCOL_HEADERS}
    layer.cc
    packet.cc
    ip.cc
    ipv4_options.cc
    ssl.cc
    tcp_options.cc
    packet_manager.cc
)

add_subdirectory(test)

install (FILES ${PROTOCOL_HEADERS}
    DESTINATION "${INCLUDE_INSTALL_PATH}/protocols"
)

=== src/pub_sub/CMakeLists.txt ===
set (PUB_SUB_INCLUDES
    appid_debug_log_event.h
    appid_event_ids.h
    appid_events.h
    assistant_gadget_event.h
    cip_events.h
    daq_message_event.h
    data_decrypt_event.h
    dcerpc_events.h
    detection_events.h
    dhcp_events.h
    dns_events.h
    domain_fronting.h
    eof_event.h
    eve_process_event.h
    expect_events.h
    external_event_ids.h
    file_events_ids.h
    file_events.h
    finalize_packet_event.h
    ftp_events.h
    http_body_event.h
    http_event_ids.h
    http_events.h
    http_publish_length_event.h
    http_request_body_event.h
    http_transaction_end_event.h
    intrinsic_event_ids.h
    netflow_event.h
    opportunistic_tls_event.h
    packet_events.h
    quic_events.h
    reputation_events.h
    rna_events.h
    shadowtraffic_aggregator.h
    sip_events.h
    smb_events.h
    ssh_events.h
    ssl_events.h
    stream_event_ids.h
    dns_payload_event.h
)

add_library( pub_sub OBJECT
    ${PUB_SUB_INCLUDES}
    cip_events.cc
    detection_events.cc
    dns_events.cc
    eof_event.cc
    http_body_event.cc
    http_events.cc
    http_request_body_event.cc
    http_transaction_end_event.cc
    quic_events.cc
    sip_events.cc
    ssh_events.cc
)

install (FILES ${PUB_SUB_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/pub_sub"
)

add_subdirectory ( test )

=== src/flow/test/CMakeLists.txt ===
add_cpputest( ha_test
    SOURCES flow_stubs.h
)

add_cpputest( deferred_trust_test
    SOURCES ../deferred_trust.cc
)

add_cpputest( flow_stash_test
    SOURCES ../flow_stash.cc
            ../../sfip/sf_ip.cc
)

add_cpputest( flow_control_test
    SOURCES ../flow_control.cc
            flow_stubs.h
)

add_cpputest( flow_cache_test
    SOURCES
        ../flow_cache.cc
        ../flow_control.cc
        ../flow_key.cc
        flow_stubs.h
        ../../hash/hash_key_operations.cc
        ../../hash/hash_lru_cache.cc
        ../../hash/primetable.cc
        ../../hash/xhash.cc
        ../../hash/zhash.cc
)

add_cpputest( session_test )

add_cpputest( flow_test
    SOURCES
        ../flow.cc
        ../flow_data.cc
        flow_stubs.h
)

=== src/pub_sub/test/CMakeLists.txt ===
if ( ENABLE_UNIT_TESTS )
    add_library(extr_cpputest_deps OBJECT EXCLUDE_FROM_ALL
        ../../sfip/sf_ip.cc
    )
endif ( ENABLE_UNIT_TESTS )

add_cpputest( pub_sub_http_event_test
    SOURCES
        ../http_events.cc
)
add_cpputest( pub_sub_http_request_body_event_test
    SOURCES
        ../http_request_body_event.cc
        ../../service_inspectors/http_inspect/http_msg_body_cl.cc
)
add_cpputest( pub_sub_http_body_event_test
    SOURCES
        ../http_body_event.cc
)
add_cpputest( pub_sub_eve_process_event_test
    SOURCES
        ../eve_process_event.h
)
add_cpputest( pub_sub_ssh_events_test
    SOURCES
        ../ssh_events.cc
)

add_cpputest( pub_sub_http_transaction_end_event_test
    SOURCES
        ../http_transaction_end_event.cc
        ../../service_inspectors/http_inspect/http_transaction.cc
        ../../service_inspectors/http_inspect/http_flow_data.cc
        ../../service_inspectors/http_inspect/http_test_manager.cc
        ../../service_inspectors/http_inspect/http_test_input.cc
        ../../service_inspectors/http_inspect/http_field.cc
    LIBS ${ZLIB_LIBRARIES}
)
add_cpputest( pub_sub_ftp_events_test
    SOURCES
        ../ftp_events.h
        $<TARGET_OBJECTS:extr_cpputest_deps>
)
add_cpputest( pub_sub_detection_events_test
    SOURCES
        ../detection_events.cc
)

=== src/service_inspectors/netflow/CMakeLists.txt ===

set ( NETFLOW_INCLUDES
    netflow_record.h
)

set ( FILE_LIST
    ${NETFLOW_INCLUDES}
    netflow_cache.h
    netflow_headers.h
    netflow_module.cc
    netflow_module.h
    netflow.cc
    netflow.h
)

if (STATIC_INSPECTORS)
    add_library( netflow OBJECT ${FILE_LIST})

else (STATIC_INSPECTORS)
    add_dynamic_module(netflow inspectors ${FILE_LIST})

endif (STATIC_INSPECTORS)

install(FILES ${NETFLOW_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/service_inspectors/netflow"
)

=== src/network_inspectors/extractor/test/CMakeLists.txt ===
if (ENABLE_BENCHMARK_TESTS)

    add_catch_test( extractor_benchmark
        SOURCES
            ../extractor_csv_logger.cc
            ../extractor_json_logger.cc
            ${CMAKE_SOURCE_DIR}/src/helpers/json_stream.cc
            ${CMAKE_SOURCE_DIR}/src/sfip/sf_ip.cc
            ${CMAKE_SOURCE_DIR}/src/utils/util_cstring.cc
            ${CMAKE_SOURCE_DIR}/src/utils/util.cc
    )

endif(ENABLE_BENCHMARK_TESTS)

=== debian/changelog ===
snort (3.10.0.0-0kali1) kali-dev; urgency=medium

  * New upstream version 3.10.0.0
  * Update debian/copyright
  * Refresh patches
  * Update minimal required version of libdaq3-dev

 -- Sophie Brun <sophie@kali.org>  Mon, 08 Dec 2025 17:09:08 +0100

=== debian/control ===
Source: snort
Section: net
Priority: optional
XSBC-Original-Maintainer: Javier Fernández-Sanguino Peña <jfs@debian.org>
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Andrew Pollock <apollock@debian.org>
Build-Depends: 
    cmake,
    libnet1-dev, 
    libpcap0.8-dev, 
    libpcre2-dev, 
    debhelper-compat (= 13), 
    po-debconf (>= 0.5.0), 
    libdumbnet-dev, 
    libdaq3-dev (>= 3.0.23-0kali1),
    flex, 
    bison,
    pkgconf,
    zlib1g-dev,
    liblzma-dev,
    libluajit-5.1-dev,
    libnghttp2-dev,
    libfl-dev,
    libhwloc-dev,
    libssl-dev
Build-Depends-Indep: 
    texlive, 
    texlive-binaries, 
    texlive-latex-base, 
    texlive-font-utils,
    latex2html,
    ghostscript
Standards-Version: 4.6.2
Homepage: https://www.snort.org/
XS-Debian-Vcs-Git: https://salsa.debian.org/jfs/pkg-snort.git
XS-Debian-Vcs-Browser: https://salsa.debian.org/jfs/pkg-snort
Vcs-Git: https://gitlab.com/kalilinux/packages/snort.git
Vcs-Browser: https://gitlab.com/kalilinux/packages/snort

Package: snort
Architecture: any
Pre-Depends: adduser (>= 3.11), ${misc:Pre-Depends}
Depends: 
    snort-common-libraries (>=${binary:Version}),
    snort-rules-default (>= ${source:Version}), 
    snort-common (>= ${source:Version}),
    debconf (>= 0.2.80) | debconf-2.0,
    rsyslog | system-log-daemon,
    logrotate,
    net-tools,
    ${shlibs:Depends},
    ${misc:Depends}
Conflicts: 
    snort-mysql, 
    snort-pgsql
Replaces: snort-common (<< 2.0.2-3)
Recommends: iproute2
Suggests: snort-doc
Description: flexible Network Intrusion Detection System
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This package provides the plain-vanilla version of Snort.

Package: snort-common
Architecture: all
Pre-Depends: adduser (>= 3.11), dpkg (>= 1.17.14), ${misc:Pre-Depends}
Depends: 
    perl, 
    debconf (>= 0.2.80) | debconf-2.0,
    ${shlibs:Depends},
    ${misc:Depends}
Conflicts: snort (<< ${binary:Version})
Replaces: snort (<< 1.8.4beta1-1)
Suggests: snort-doc
Description: flexible Network Intrusion Detection System - common files
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This is a common package which holds cron jobs, tools, and config files
 used by all the different package flavors.

Package: snort-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Section: doc
Description: flexible Network Intrusion Detection System - documentation
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This package provides the documentation for Snort.

Package: snort-rules-default
Provides: snort-rules
Architecture: all
Depends: 
    debconf (>= 0.2.80) | debconf-2.0, 
    adduser (>= 3.11), 
    ${shlibs:Depends}, 
    ${misc:Depends}
Suggests: snort (>= 2.2.0) | snort-pgsql (>= 2.2.0) | snort-mysql (>= 2.2.0)
Recommends: oinkmaster
Homepage: http://www.snort.org/snort-rules/
Description: flexible Network Intrusion Detection System - ruleset
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This is the Snort default ruleset, which provides a basic set of network
 intrusion detection rules developed by the Snort community. They can be
 used as a basis for development of additional rules. Users using Snort to
 defend networks in production environments are encouraged to update their
 local rulesets as described in the included documentation or using the
 oinkmaster package.

Package: snort-common-libraries
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: snort (>= 2.7.0) | snort-pgsql (>= 2.7.0) | snort-mysql (>= 2.7.0)
Conflicts: snort-common (<< 2.7.0-6)
Description: flexible Network Intrusion Detection System - libraries
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This package provides libraries used by all the Snort binary packages.
